class Api::OrdersController < Api::BaseController
  resource_controller_for_api
  actions :index, :show

  private

    def object_serialization_options
      { :include => {
          :bill_address => { :include => [:state, :country] },
          :ship_address => { :include => [:state, :country] },
          :shipments => {:include => [:shipping_method, :address]},          
          :line_items => {:include => [:variant], :methods => [:tax_category_id]}
          } 
      }
    end

end
