map.namespace :admin do |admin|
  admin.resources :users, :member => {:generate_api_key => :put, :clear_api_key => :put}
end
map.namespace :api do |api|
  api.resources :shipments, :except => [:new,:edit], :member => {:event => :put} do |shipments|
    shipments.resources :inventory_units, :except => [:new,:edit], :member => {:event => :put}
  end
  api.resources :orders, :except => [:new,:edit], :member => {:event => :put} do |orders|
    orders.resources :shipments, :except => [:new,:edit]
    orders.resources :line_items, :except => [:new,:edit]
    orders.resources :inventory_units, :except => [:new,:edit], :member => {:event => :put}
  end
  api.resources :inventory_units, :except => [:new,:edit], :member => {:event => :put}
  api.resources :products, :except => [:new,:edit], :member => {:event => :put} do |products|
    products.resources :variants, :except => [:new, :edit]
  end
  api.resources :taxons, :except => [:new, :edit]
  api.resources :users, :except => [:new, :edit]
  api.resources :addresses, :except => [:new, :edit]
  api.resources :variants, :except => [:new, :edit]
  api.resources :promotions, :except => [:new, :edit]
  api.resources :tax_categories, :except => [:new, :edit]
end
