# -*- encoding: utf-8 -*-
##############################################################################
#
#    OpenERP, Open Source Management Solution
#    Copyright (c) 2010 Ting! All Rights Reserved.
#                      
#    $Id$
#
#    This program is free software: you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation, either version 3 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program.  If not, see <http://www.gnu.org/licenses/>.
#
##############################################################################

import pooler
import wizard
from tools.translate import _

_form = '''<?xml version="1.0" encoding="utf-8"?>
<form string="Product Stock Export">
    <label string="WARNING: This wizard will make changes in the stock of the selected products in Spree. You have to be secure of what are you doing" colspan="4"/>
    <newline/>
    <field name="product_ids" width="400" colspan="4"/>
</form>'''
_fields = {
    'product_ids': {'string':'Products', 'type': 'many2many', 'relation': 'esale.spree.product', 'required': True} 
}

class export_stocks(wizard.interface):
    def _get_defaults(self, cr, uid, data, context={}):
        if data['model'] == 'esale.spree.product':
            data['form']['product_ids'] = data['ids']
        return data['form']
    def _export(self, cr, uid, data, context={}):
        pool = pooler.get_pool(cr.dbname)
        esale_product_ids = data['form']['product_ids'][0][2]
        pool.get('esale.spree.web').inventory_export(cr, uid, data['ids'], esale_product_ids = esale_product_ids)
            

    states = {
        'init': {
            'actions': [_get_defaults],
            'result': {'type':'form', 'arch':_form, 'fields':_fields, 'state':[('end','Cancel','gtk-no'),('export_product_stocks','Export Stocks','gtk-yes')]}
        },
        'export_product_stocks': {
            'actions': [],
            'result': {'type':'action', 'action':_export, 'state':'end'}
        }
    }
export_stocks('spree.export.stocks')
