# -*- encoding: utf-8 -*-
##############################################################################
#
#    OpenERP, Open Source Management Solution
#    Copyright (c) 2010 Ting! All Rights Reserved.
#                      
#    $Id$
#
#    This program is free software: you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation, either version 3 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program.  If not, see <http://www.gnu.org/licenses/>.
#
##############################################################################

import pooler
import wizard
from tools.translate import _

_form = '''<?xml version="1.0" encoding="utf-8"?>
<form string="Product Stock Import">
    <label string="This wizard will create a periodical inventory. You have to confirm it to establish the stock of the products."/>
    <newline/>
    <field name="product_ids" colspan="4"/>
</form>'''
_fields = {
    'product_ids': {'string':'Products', 'type': 'many2many', 'relation': 'esale.spree.product', 'required': True} 
}

class import_stocks(wizard.interface):
    def _get_defaults(self, cr, uid, data, context={}):
        if data['model'] == 'esale.spree.product':
            data['form']['product_ids'] = data['ids']
        return data['form']
    def _import(self, cr, uid, data, context={}):
        pool = pooler.get_pool(cr.dbname)
        esale_product_ids = data['form']['product_ids'][0][2]
        pool.get('esale.spree.web').inventory_import(cr, uid, data['ids'], esale_product_ids = esale_product_ids)
            

    states = {
        'init': {
            'actions': [_get_defaults],
            'result': {'type':'form', 'arch':_form, 'fields':_fields, 'state':[('end','Cancel','gtk-no'),('import_product_stocks','Import Stocks','gtk-yes')]}
        },
        'import_product_stocks': {
            'actions': [],
            'result': {'type':'action', 'action':_import, 'state':'end'}
        }
    }
import_stocks('spree.import.stocks')
