# -*- encoding: utf-8 -*-
##############################################################################
#
#    OpenERP, Open Source Management Solution    
#    Copyright (C) 2004-2009 Smile.fr . All Rights Reserved
#    @author Raphaël Valyi
#
#    This program is free software: you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation, either version 3 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program.  If not, see <http://www.gnu.org/licenses/>.
#
##############################################################################

from osv import fields,osv
from tools.translate import _

class stock_production_lot(osv.osv):
    _inherit = "stock.production.lot"

    def _is_warranty_expired(self, cr, uid, ids, field_name, arg, context={}):
        res = {}
        for last_location in self.read(cr, uid, ids, ['last_location_id']):
            if last_location['last_location_id'] and self.pool.get('stock.location').browse(cr, uid, last_location['last_location_id'][0]).is_expired:
                res[last_location['id']] = True
            else:
                res[last_location['id']] = False
        return res
    
    _columns = {
        'is_warranty_expired': fields.function(_is_warranty_expired, method=True, type="boolean", string="Is warranty expired?", readonly=True, help="Tells if the product is currently located in a sub-fleet with an expired warranty"),
    }

stock_production_lot()