# -*- encoding: utf-8 -*-
##############################################################################
#
#    Copyright (C) 2010 Cogetix BVBA (<http://www.cogetix.com>). 
#    All Rights Reserved
#    $Id$
#
#    This program is free software: you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation, either version 3 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program.  If not, see <http://www.gnu.org/licenses/>.
#
##############################################################################

from osv import osv, fields

class partner_category(osv.osv):
    _inherit = 'res.partner.category'
    _columns = {
        'company_id': fields.many2one('res.company', 'Company',select=1, help="The \"Company\" field is used to filter data in the \"Company Partners\" view.")
        }
    
    def _get_company(self, cr, uid, id, context=None):
        if context is None:
            context={}
        return self.pool.get('res.partner.category').browse(cr, uid, id, context).company_id.id
    
    def _default_company(self, cr, uid, context=None):
        if context is None:
            context={}
        return self.pool.get('res.users').browse(cr, uid, uid, context).company_id.id
        
    def onchange_parent_id(self, cr, uid, ids, parent_id, context=None):
        if context is None:
            context={}
        
        v={}

        if parent_id:
            parent_company = self._get_company(cr, uid, parent_id, context)
            if parent_company:
                v['company_id'] = parent_company
        return {'value': v}
    
    _defaults = {  
        'company_id': _default_company,  
        }
partner_category()

class ir_action_window(osv.osv):
    _inherit = 'ir.actions.act_window'

    def read(self, cr, uid, ids, fields=None, context=None,
            load='_classic_read'):
        select = ids
        if isinstance(ids, (int, long)):
            select = [ids]
        res = super(ir_action_window, self).read(cr, uid, select, fields=fields,
                context=context, load=load)
        for r in res:
            mystring = 'get_company_categories()'
            user_obj = self.pool.get('res.users').browse(cr, uid, uid)
            if mystring in (r.get('domain', '[]') or ''):
                r['domain'] = r['domain'].replace(mystring, str(
                    self.pool.get('res.partner.category').search(cr, uid, [('company_id', '=', user_obj.company_id.id)])))
        if isinstance(ids, (int, long)):
            if res:
                return res[0]
            else:
                return False
        return res

ir_action_window()
# vim:expandtab:smartindent:tabstop=4:softtabstop=4:shiftwidth=4:

