# -*- coding: utf-8 -*-
##############################################################################
#
# Copyright (c) 2009 Albert Cervera i Areny <albert@nan-tic.com>
#
# WARNING: This program as such is intended to be used by professional
# programmers who take the whole responsability of assessing all potential
# consequences resulting from its eventual inadequacies and bugs
# End users who are looking for a ready-to-use solution with commercial
# garantees and support are strongly adviced to contract a Free Software
# Service Company
#
# This program is Free Software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; either version 2
# of the License, or (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
#
##############################################################################

import time
import subprocess
import cups

import netsvc
from osv import fields
from osv import osv
from tools.translate import _


class printjob_printer_update_wizard(osv.osv_memory):
    _name = "printjob.printer.update.wizard"

    _columns = {
    }

    def action_cancel(self, cr, uid, ids, context=None):
        return {}

    def action_ok(self, cr, uid, ids, context=None):
        # Update CUPS URL
        url = 'https://%s:%s' % ( cups.getServer(), cups.getPort() )

        id = self.pool.get('ir.model.data')._get_id(cr, uid, 'printjob', 'action_open_cups')
        id = self.pool.get('ir.model.data').browse(cr, uid, id, context).res_id
        self.pool.get('ir.actions.url').write(cr, uid, [id], {
            'url': url,
        }, context)

        # Update Printers
        try:
            connection = cups.Connection()
            printers = connection.getPrinters()
        except:
            return {}

        ids = self.pool.get('printjob.printer').search(cr, uid, [('system_name','in',printers.keys())], context=context)
        for printer in self.pool.get('printjob.printer').browse(cr, uid, ids, context):
            del printers[printer.system_name]
       
        for name in printers:
            printer = printers[name]
            self.pool.get('printjob.printer').create(cr, uid, {
                'name': printer['printer-info'],
                'system_name': name,
                'model': printer.get('printer-make-and-model', False),
                'location': printer.get('printer-location', False),
                'uri': printer.get('device-uri', False),
            }, context)

        return {}

printjob_printer_update_wizard()

# vim:expandtab:smartindent:tabstop=4:softtabstop=4:shiftwidth=4:
