##############################################################################
#
#    OpenERP, Open Source Management Solution    
#    Copyright (C) 2010 Ting! <http://www.ting.es> <hugo.santos@ting.es>. All Rights Reserved
#    d$
#
#    This program is free software: you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation, either version 3 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program.  If not, see <http://www.gnu.org/licenses/>.
#
##############################################################################

from osv import osv, fields

class product_product(osv.osv):    
    _name = 'product.product'
    _inherit = 'product.product'
    
    _columns = {
        'is_master': fields.boolean('Master Product', help="Is a master product that can have variants or is a product without them."),
        'master_product_id': fields.many2one('product.product', 'Master Product'),
        'product_variants_ids': fields.one2many('product.product', 'master_product_id', 'Product Variants'),
    }
    
    _defaults = {
        'is_master': lambda *a: True
    }
    
    
        
product_product()
