import wizard
import netsvc
import ir
import pooler
from tools.misc import UpdateableStr, UpdateableDict
from osv import osv

_fields_sorting = UpdateableDict()
_form_sorting = UpdateableStr()

selection = [
    ('product_name', 'Product Name'),
    ('product_variants', 'Product Variants'),
    ('product_code', 'Product Code'),
    ('product_category', 'Product Category'),
]

model_lines = {
    'sale.order': 'order_line',
    'stock.picking': 'move_lines',
    'account.invoice': 'invoice_line',
    'purchase.order': 'order_line',
}

selection2fc = {
    'product_name': 'l.product_id.name',
    'product_variants': 'l.product_id.variants',
    'product_code': 'l.product_id.default_code',
    'product_category': 'l.product_id.categ_id.name',
}

def add_variant(num):
    for i in range(num):
        selection2fc.update( {'variant%d'%(i+1): 'get_variant(l.product_id.variants, %d)'%i} )
        selection.append( ('variant%d'%(i+1), 'Variant %d'%(i+1)) )
        #('get_variant(l.product_id.variants, %d)'%i, 'Variant %d'%(i+1))
NUM_VARIANTS = 2
SEP_VARIANTS = '/'
add_variant(NUM_VARIANTS)

def get_variant(variants, i, sep=SEP_VARIANTS, with_sep_ini=True):
    variants_lst = (variants or '').split(sep)
    _i = (with_sep_ini and i+1) or i
    variant = (variants_lst[_i:_i+1] or [False])[0] or ''#Empieza desde [i+1] por que la 1ra. no cuenta, ya que es de tipo '/variante1/variante2', y es de tipo rango :, ya que cuando se sale del rango no marca except y devuelve una lista vacia []
    return variant

def _get_fields_and_form_sorting(self, cr, uid, data, context):
    res = {}
    _fields_sorting.clear()
    _form_sorting_lst = ['<?xml version="1.0"?>', '<form string="Sequence order">']
    #_form_sorting_lst.append( '<separator string="Values" colspan="4"/>' )
    for i in range( len(selection) ):
        _fields_sorting['type%d'%(i+1)] = {
            'string': 'Priority %d'%(i+1), 
            'type': 'selection', 
            'selection': selection + [ (False, '') ],
            'default': selection[i][0],
        }
        _form_sorting_lst.append( '<field name="type%d"/>'%(i+1) )
        _form_sorting_lst.append( '<newline/>' )
        res.setdefault('types', []).append( i+1 )
    _form_sorting_lst.append( '<separator string="Sorting" colspan="4"/>' )
    _fields_sorting['sorting'] = {'string': 'Sorting', 'type': 'selection', 'selection': [('asc', 'Ascending'), ('desc', 'Descending')], 'default': 'asc'}
    _form_sorting_lst.append( '<field name="sorting" nolabel="1" colspan="4"/>')
    _form_sorting_lst.append('</form>')
    _form_sorting.string = '\n'.join(_form_sorting_lst)
    return res

def _set_order(self, cr, uid, data, context={}):
    model = data['model']
    obj = pooler.get_pool(cr.dbname).get(model)
    ids = data['ids']
    lines = model_lines.get( model, False )
    if lines:
        for r in obj.browse(cr, uid, ids, context):
            new_lines = []
            word_id = {}
            for l in r[lines]:
                word = ""
                types = data['form']['types']
                for i in range(len(types)):
                    type = selection2fc[ data['form']['type%d'%(types[i])] ]
                    if type:
                        word += (eval(type) or '') + ' '
                word_id.update( {word+'_'+str(l['id']): l['id']} )
                #print "*******", word
            seq = 0
            for key in sorted( word_id.keys(), reverse = data['form']['sorting'] == 'desc' ):
                seq += 10
                new_lines.append( ( 1, word_id[key], {'sequence': seq} ) )
            new_data = {lines: new_lines}
            #print "r: ", r, "new_data: ", new_data
            obj.write(cr, uid, [r['id']], new_data)
    else:
        print "Lines: ", lines, "NO definidas."
    return {}

class wizard_sequence_order(wizard.interface):
    states = {
        'init' : { 'actions': [_get_fields_and_form_sorting],
            'result': { 'type': 'form', 'arch': _form_sorting, 'fields': _fields_sorting, 'state': [ ('end', 'Cancel'), ('confirm', 'Confirm')]},
        },
        'confirm' : { 'actions' : [_set_order],
            'result' : {'type': 'state', 'state': 'end'},
        },
    }
wizard_sequence_order("wizard.sequence.order")
