# -*- encoding: latin-1 -*-
##############################################################################
#
# Copyright (c) 2010 Ana Juaristi (http://www.openerpsite.com) All Rights Reserved.
#
#
# WARNING: This program as such is intended to be used by professional
# programmers who take the whole responsability of assessing all potential
# consequences resulting from its eventual inadequacies and bugs
# End users who are looking for a ready-to-use solution with commercial
# garantees and support are strongly adviced to contract a Free Software
# Service Company
#
# This program is Free Software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; either version 2
# of the License, or (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
#
##############################################################################

from osv import fields,osv
from tools.translate import _


class stock_picking(osv.osv):
    _inherit = 'stock.picking'

    def totals(self, cr, uid, ids, *args):
        pickings = self.browse(cr, uid, ids)
        for picking in pickings:
            gross_weight = 0.0
            net_weight = 0.0
            packages = 0.0

            for move in picking.move_lines:
                gross_weight += move.gross_weight 
                net_weight += move.net_weight 
                packages += move.packages
            self.write(cr, uid, picking.id, {'gross_weight': gross_weight, 'packages': packages, 'net_weight': net_weight })
        return True

    _columns = {
        'gross_weight': fields.integer('Gross Weight', required=False, readonly=False, help='Gross Weight'),
        'net_weight': fields.integer('Net Weight', required=False, readonly=False, help='Net Weight'),
        'vehicle': fields.char('Vehicle identification', size=32, readonly=False),
    }
stock_picking()


class stock_move(osv.osv):
    _inherit = 'stock.move'
    _order = "sequence"
     

    _columns = {
        'sequence': fields.integer('Sequence number'), 
        'packages': fields.integer('Packages', required=False, readonly=False, help='Number of packages to deliver by line.'),
        'net_weight': fields.integer('Net weight'), 
        'gross_weight': fields.integer('Gross weight'), 
    }
stock_move()

# vim:expandtab:smartindent:tabstop=4:softtabstop=4:shiftwidth=4:
