##############################################################################
#
#    OpenERP, Open Source Management Solution    
#    Copyright (C) 2004-2009 Tiny SPRL (<http://tiny.be>). All Rights Reserved
#    d$
#
#    This program is free software: you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation, either version 3 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program.  If not, see <http://www.gnu.org/licenses/>.
#
##############################################################################


from osv import osv
from osv import fields

class sale_order_line(osv.osv):
    
    _name = 'sale.order.line'
    _inherit = 'sale.order.line'
    
    def price_by_product(self, cr, uid, ids, pricelist, product_id, qty=0, partner_id=False):
        values = {}
        if not product_id:
            return values
        if not pricelist:
            raise osv.except_osv(_('No Pricelist !'),
                _('You have to select a pricelist in the sale form !\n' \
                'Please set one before choosing a product.'))

        price = self.pool.get('product.pricelist').price_get(cr, uid,
            [pricelist], product_id, qty or 1.0, partner_id)[pricelist]
        if price is False:
            raise osv.except_osv(_('No valid pricelist line found !'),
                _("Couldn't find a pricelist line matching this product" \
                " and quantity.\nYou have to change either the product," \
                " the quantity or the pricelist."))
        product_obj = self.pool.get('product.product').browse(cr, uid, product_id)
        values['price_unit'] = price
        values['name'] = product_obj.name_get()[0][1]
        values['product_uos_qty'] = qty        
        values['product_uom'] = product_obj.uom_id.id
        return values
   
    
    def product_id_tree_change(self, cr, uid, ids, pricelist, product_id, qty=0, partner_id=False):
        values = self.price_by_product(cr, uid, ids, pricelist, product_id, qty, partner_id)
        return {'value': values}

sale_order_line()
